<?php
// +-----------------------------------------------------------------------+
// | FacebookPlug - a Piwigo Plugin                                        |
// | Copyright (C) 2010 Ruben ARNAUD - rub@piwigo.org                      |
// +-----------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or modify  |
// | it under the terms of the GNU General Public License as published by  |
// | the Free Software Foundation                                          |
// |                                                                       |
// | This program is distributed in the hope that it will be useful, but   |
// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
// | General Public License for more details.                              |
// |                                                                       |
// | You should have received a copy of the GNU General Public License     |
// | along with this program; if not, write to the Free Software           |
// | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, |
// | USA.                                                                  |
// +-----------------------------------------------------------------------+

if (!defined('PHPWG_ROOT_PATH'))
{
  die('Hacking attempt!');
}

function fbp_header($content, &$smarty)
{
  global $conf;

  // replace tag html
  $search = '<html ';
  $replacement = '<html xmlns:fb="http://www.facebook.com/2008/fbml" ';

  //~ $content = preg_replace('#'.$search.'#', $replacement, $content);
  return preg_replace('#'.$search.'#', $replacement, $content);
  //~ $fbp_content = file_get_contents(FBP_DIR.'/tpl/init.fb.tpl');

  $search = '<div id="the_page">';
  return preg_replace('#'.$search.'#', $fbp_content.$search, $content);
}

function fbp_loc_begin_picture()
{
  global $template, $user, $page, $conf, $picture;

  // set prefilter
  $template->set_prefilter('header', 'fbp_header');

  $template->assign('FACEBOOK_APP_ID', FACEBOOK_APP_ID);
  // define language
  $template->assign('LANGUAGE', $user['language']);
  $template->assign('fbp', $conf['fbp']);
  $template->smarty->register_modifier('boolean_to_string', 'boolean_to_string');

  $template->set_filename('init.fb', FBP_DIR.'/tpl/init.fb.tpl');
  $template->append('head_elements', $template->parse('init.fb', true));
}

function fbp_render_element_content($content, $current_picture)
{
  global $template, $user, $page, $conf, $picture;

  if ($page['slideshow'])
  {
    // nothing to do on slideshow other media aren't usable
    return $content;
  }

  if ($conf['fbp']['social_plugin_like_button']['enabled'] or $conf['fbp']['social_plugin_like_box']['enabled'])
  {
    // define picture FB link
    // Always use full url for FB social plugin
    set_make_full_url();
    if ($conf['fbp']['social_plugin_like_button']['url_type'] == 'image')
    {
      $fbp_url_picture = get_element_url($current_picture);
    }
    else
    {
      $fbp_url_picture = make_picture_url(array('image_id' => $page['image_id']));
    }
    unset_make_full_url();
    $template->assign('fbp_url_picture', $fbp_url_picture);
    //~ $template->assign('FBP_SOCIAL_PLUGIN_LIKE_BUTTON', $conf['fbp']['social_plugin_like_button']);
    //~ $template->assign('FBP_SOCIAL_PLUGIN_LIKE_BOX', $conf['fbp']['social_plugin_like_box']);

     // iframe implementation
    /*  $$content = '
    <iframe src="http://www.facebook.com/plugins/like.php?href={$SRC_IMG}&amp;layout=standard&amp;show_faces=true&amp;width={$WIDTH_IMG}&amp;action=like&amp;colorscheme=light&amp;height=80" scrolling="no" frameborder="0" style="border:none; overflow:hidden; width:{$WIDTH_IMG}px; height:80px;" allowTransparency="true"></iframe>
    ';*/
    // XFBML implementation
    //~ $content .= '
//~ <div id="fb-xfbml">';
    if ($conf['fbp']['social_plugin_like_button']['enabled'])
    {
      //~ $content .= '
//~ <div id="fb-xfbml">
//~ <fb:like href="'.$fbp_url_picture.'" layout="'.$conf['fbp']['social_plugin_like_button']['layout'].'" show_faces="'.boolean_to_string($conf['fbp']['social_plugin_like_button']['show_faces']).'" width="'.@$current_picture['scaled_width'].'" action="'.$conf['fbp']['social_plugin_like_button']['action'].'" colorscheme="'.$conf['fbp']['social_plugin_like_button']['colorscheme'].'"></fb:like>
//~ </div>';
      $template->set_filename('social.plugin.like.button', FBP_DIR.'/tpl/social.plugin.like.button.tpl');
      $content .= $template->parse('social.plugin.like.button', true);
    }
    if ($conf['fbp']['social_plugin_like_box']['enabled'])
    {
      //~ $content .= '
//~ <div id="fb-xfbml">
//~ <fb:like-box href="'.$fbp_url_picture.'" width="'.@$current_picture['scaled_width'].'" show_faces="'.boolean_to_string($conf['fbp']['social_plugin_like_box']['show_faces']).'" stream="'.boolean_to_string($conf['fbp']['social_plugin_like_box']['stream']).'" header="'.boolean_to_string($conf['fbp']['social_plugin_like_box']['header']).'"></fb:like-box>
//~ </div>';
      $template->set_filename('social.plugin.like.box', FBP_DIR.'/tpl/social.plugin.like.box.tpl');
      $content .= $template->parse('social.plugin.like.box', true);
    }

    //~ $content .= '
//~ </div>';
}

  return $content;
}

function ftp_loc_end_section_init()
{
  global $conf;

  if ($conf['fbp']['social_plugin_like_button']['enabled'] or $conf['fbp']['social_plugin_like_box']['enabled'])
  {
    if ($conf['fbp']['allow_fb_access_private_page'])
    {
      global $user, $page;

      // No restristion for facebook user
      if (preg_match('/'.FBP_IP_FB. '/', $_SERVER["REMOTE_ADDR"]))
      {
        //Allow guest access
        $conf['guest_access'] = true;
        // No forbidden categorie
        $user['forbidden_categories'] = '';
        $user['level'] = max($conf['available_permission_levels']);
        $page['rank_of'][$page['image_id']] = 0;
        $page['items'] = array_flip($page['rank_of']);
      }
    }
  }
}

if ($conf['fbp']['social_plugin_like_button']['enabled'] or $conf['fbp']['social_plugin_like_box']['enabled'])
{
  add_event_handler('loc_begin_picture', 'fbp_loc_begin_picture');
  add_event_handler('render_element_content', 'fbp_render_element_content', EVENT_HANDLER_PRIORITY_NEUTRAL+1 /*in order to have picture content*/, 2);
  //~ add_event_handler('loc_end_picture', 'fbp_loc_end_picture');
  add_event_handler('loc_end_section_init', 'ftp_loc_end_section_init');
}

?>
